#include <Wire.h>
#include <dummy.h> 

//for esp32
extern TwoWire I2Cone= TwoWire(0);
extern TwoWire I2Ctwo= TwoWire(1);

#define FDC1 0x50
#define FDC2 0x50
#define NUM_SENSORS 4  
int OFFSET= 0; //in pF
int OFFSET2 = OFFSET;
double data_list1[6] = { };
double data_list2[6] = { };


void setup() {
  delay(1000); 
  Serial.println("Going through setup");
  Serial.println("");
  Serial.println("Going through setup");
  Serial.println("");
  Serial.println("Going through setup");
  Serial.println("");
  delay(1000); 
  int capdac = 0; //capdac = round(OFFSET/3.125);
  Serial.begin(115200);
  Serial.println("");
  I2Cone.begin(21, 22, 100000);// I2C pins on FDC1 --> default I2C pins
  I2Ctwo.begin(33, 32, 100000); //I2C pins on FDC2

  //to not having the flipping and the wrong registers set-up, I  reset twice the second FDC (pins 33,32) and once the first(21,22)
  // Nothing changes if I reset both FDC twice
  I2Cone.beginTransmission(FDC1);
  I2Cone.write(0x0C);
  I2Cone.write(0x80); 
  I2Cone.endTransmission();
  // I2Cone.beginTransmission(FDC1); 
  // I2Cone.write(0x0C);
  // I2Cone.write(0x80); 
  // I2Cone.endTransmission();
  I2Ctwo.beginTransmission(FDC2);
  I2Ctwo.write(0x0C);
  I2Ctwo.write(0x80); 
  I2Ctwo.endTransmission();
  I2Ctwo.beginTransmission(FDC2);
  I2Ctwo.write(0x0C);
  I2Ctwo.write(0x80); 
  I2Ctwo.endTransmission();

  //Initiate CIN 1-4 for single ended measurement --> configuration registers (0x08, 0x09, 0x0A,0x0B)
    I2Ctwo.write(highByte(register_value) + 32*i);
  //Caculate register value from CAPDAC value 
  for (int i = 0; i < NUM_SENSORS; i++) {  
    int register_value = 0x1000 + (capdac << 5);
    I2Cone.beginTransmission(FDC1); 
    I2Cone.write(0x08 + i); 
    I2Cone.write(highByte(register_value) + 32*i);
    I2Cone.write(lowByte(register_value));
    I2Cone.endTransmission();
    I2Ctwo.beginTransmission(FDC2);  
    I2Ctwo.write(0x08 + i);    
    I2Ctwo.write(highByte(register_value) + 32*i);
    I2Ctwo.write(lowByte(register_value));
    I2Ctwo.endTransmission();
  }
  //Initiate measurements with data rate of 100S/s and continuous measurements 
  I2Cone.beginTransmission(FDC1); 
  I2Cone.write(0x0C); //FDC Configuration Register 0x0C
  I2Cone.write(0x05); //sampling rate
  I2Cone.write(0xF0); //initiate all measurements 
  I2Cone.endTransmission();
  I2Ctwo.beginTransmission(FDC2); 
  I2Ctwo.write(0x0C); //FDC Configuration Register 0x0C
  I2Ctwo.write(0x05); //sampling rate
  I2Ctwo.write(0xF0); //initiate all measurements
  I2Ctwo.endTransmission();
  Serial.println("Process can start");

  //Calibration --> wait to be sure to acquire your data
  Serial.println("Calibration...");
  if (isReady1(0)) { //True if measurement at position 0 is completed = MEAS1
    data_list1[0] = readC1(0); //Read MEAS1
  }
  if (isReady1(1)) { 
    data_list1[1] = readC1(1); 
  }
  if (isReady1(2)) { 
    data_list1[2] = readC1(2); 
  }
  if (isReady1(3)) { 
    data_list1[3] = readC1(3); 
  }

  if (isReady2(0)) { 
    data_list2[0] = readC2(0); 
  }

  if (isReady2(1)) { 
    data_list2[1] = readC2(1); 
  }

  if (isReady2(2)) { 
    data_list2[2] = readC2(2); 
  }

  if (isReady2(3)) { 
    data_list2[3] = readC2(3); 
  }

  // during calibration the system waits  until the channels are correclty read and associated to the sensors
  while (data_list1[0] == 0 || data_list1[1] == 0 || data_list1[2] == 0 || data_list1[3] == 0) { 
  // if either of the read values is 0, it means there is an error and I have to read again the whole set of measurements
    if (isReady1(0)) {
      data_list1[0] = readC1(0);
    }
    if (isReady1(1)) {
      data_list1[1] = readC1(1);
    }
    if (isReady1(2)) {
      data_list1[2] = readC1(2);
    }
    if (isReady1(3)) {
      data_list1[3] = readC1(3);
    }
  } 
  while (data_list2[0] == 0 || data_list2[1] == 0 || data_list2[2] == 0 || data_list2[3] == 0) { 
    if (isReady2(0)) {
      data_list2[0] = readC2(0);
    }
    if (isReady2(1)) {
      data_list2[1] = readC2(1);
    }
    if (isReady2(2)) {
      data_list2[2] = readC2(2);
    }
    if (isReady2(3)) {
      data_list2[3] = readC2(3);
    }
  } 
}


void loop() {
  Serial.println("Values for the first FDC:");
  Serial.println("");
  //the system waits  until the channels are correclty read and associated to the sensors
  while (data_list1[0] == 0 || data_list1[1] == 0 || data_list1[2] == 0 || data_list1[3] == 0) { 
  // 
    if (isReady1(0)) {
      data_list1[0] = readC1(0);
    }
    if (isReady1(1)) {
      data_list1[1] = readC1(1);
    }
    if (isReady1(2)) {
      data_list1[2] = readC1(2);
    }
    if (isReady1(3)) {
      data_list1[3] = readC1(3);
    }
  } 
  while (data_list2[0] == 0 || data_list2[1] == 0 || data_list2[2] == 0 || data_list2[3] == 0) { 
    if (isReady2(0)) {
      data_list2[0] = readC2(0);
    }
    if (isReady2(1)) {
      data_list2[1] = readC2(1);
    }
    if (isReady2(2)) {
      data_list2[2] = readC2(2);
    }
    if (isReady2(3)) {
      data_list2[3] = readC2(3);
    }
  }

  //CHECK if reading is ok, if yes printout the values for both FDC
  if (isReady1(0)) {
    data_list1[0] = readC1(0);
  }
  if (isReady1(1)) {
    data_list1[1] = readC1(1);
  }
  if (isReady1(2)) {
    data_list1[2] = readC1(2);
  }
  if (isReady1(3)) {
    data_list1[3] = readC1(3);
  }
  for (int i = 0; i < NUM_SENSORS; i++) {
    Serial.print("CH" + String(i+1) + ":" + String(data_list1[i], 5) + " " );
  }
  Serial.println("");

  Serial.println("Values for the second FDC:");
  Serial.println("");
  if (isReady2(0)) {
    data_list2[0] = readC2(0);
  }
  if (isReady2(1)) {
    data_list2[1] = readC2(1);
  }
  if (isReady2(2)) {
    data_list2[2] = readC2(2);
  }
  if (isReady2(3)) {
    data_list2[3] = readC2(3);
  }
  for (int i = 0; i < NUM_SENSORS; i++) {
    Serial.print("CH" + String(i+5) + ":" + String(data_list2[i], 5) + " " );
  }
  Serial.println("");
  Serial.println("");
  Serial.println("------------------------------");
  Serial.println("");
  delay(1000); 
}

//Input: Number of input pin (starts at 0)
//Output: True if measurement at position cin_n is completed, false otherwise 
bool isReady1(int cin_n) {
  int32_t fdcone[4];
  int i = 0;
  I2Cone.beginTransmission(FDC1); 
  I2Cone.write(0x0C);  //FDC config register
  I2Cone.endTransmission();
  I2Cone.requestFrom(FDC1, 4);
  while (I2Cone.available()) {
    fdcone[i] = I2Cone.read(); 
    i++;
  }
  return bitRead(fdcone[1], 5 - cin_n); 
}

bool isReady2(int cin_n) {
  int32_t fdctwo[4];
  int i = 0;
  I2Ctwo.beginTransmission(FDC2); 
  I2Ctwo.write(0x0C);  
  I2Ctwo.endTransmission();
  I2Ctwo.requestFrom(FDC2, 4);
  while (I2Ctwo.available()) {
    fdctwo[i] = I2Ctwo.read(); 
    i++;
  }
  return bitRead(fdctwo[1], 5 - cin_n);
}



//Input: Number of input pin (starts at 0) //Output: -
//Prints capacitance at input cin_n to serial 
double readC1(int cin_n) {
  int32_t c;
  int32_t c_data1[4]; 
  int capdac = 0;
  int coffset = capdac * 3.125;
  I2Cone.beginTransmission(FDC1); 
  I2Cone.write(0x00 + cin_n * 2); 
  I2Cone.endTransmission();
  I2Cone.requestFrom(FDC1, 4);
  //Read Measurement results on CINx
  for (int i = 0; i < 4; i++) { 
    c_data1[i] = I2Cone.read();
  }
  //Convert byte array to int and print capacitance to serial
  c = (c_data1[0] << 16) + (c_data1[1]<<8) + c_data1[2];
  //get the 2's ocmplement
  if (c & 0x800000) { // Check if value is negative
    c = ~c + 1; // Invert all bits and add 1
  }
  float cap1 = ((float)(c)/ 524288.0)+ coffset; // 524288.0 = 2^19
  return cap1;
}

double readC2(int cin_n) {
  int32_t c;
  int8_t c_data2[4]; 
  int capdac = 0;
  int coffset = capdac * 3.125;
  I2Ctwo.beginTransmission(FDC2); 
  I2Ctwo.write(0x00 + cin_n * 2); 
  I2Ctwo.endTransmission();
  I2Ctwo.requestFrom(FDC2, 4);
  //Read Measurement results on CINx
  for (int i = 0; i < 4; i++) { 
  c_data2[i] = I2Ctwo.read();
  }
  //Convert byte array to int and print capacitance to serial
  c = ((uint32_t)c_data2[0] << 16) + ((uint32_t)c_data2[1]<<8) + (uint32_t)c_data2[2];
  //get the 2's complement
  if (c & 0x800000) { // Check if value is negative
    c = ~c + 1; // Invert all bits and add 1
  }
  float cap2 = ((float)(c)/ 524288.0)+ coffset; // 524288.0 = 2^19
  return cap2;
}
 
